// --------------------------------------------------------------------
// Copyright (c) 2009 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
// Major Functions:	Ethernet Card  
//
// --------------------------------------------------------------------
//
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Eric Chen         :| 09/04/30  :| Initial Revision
// --------------------------------------------------------------------

`default_nettype none
`define	NET1

//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================
module DE3_NET_DDR2(

		////////// CLOCK //////////
		OSC_BA,
		OSC_BB,
		OSC_BC,
		OSC_BD,
		OSC1_50,
		OSC2_50,
		CLK_OUT,
		EXT_CLK,

		////////// LED //////////
		LEDR,
		LEDG,
		LEDB,

		////////// SEG7 //////////
		HEX0,
		HEX0_DP,
		HEX1,
		HEX1_DP,

		////////// BUTTON //////////
		Button,
		CPU_RESETn,
		
		////////// SW (SLIDE SWITCH) //////////
		SW,

		////////// DIP_SW (DIP SWITCH) //////////
		DIP_SW,

		////////// mem (J9, DDR2 SO-DIMM), connect to DDR2_SODIMM(DDR2_SODIMM Board) //////////
		mem_cke,
		mem_addr,
		mem_ba,
		mem_ras_n,
		mem_we_n,
		mem_cas_n,
		mem_cs_n,
		mem_odt,
		mem_clk,
		mem_clk_n,
		mem_dm,
		mem_dqsn,
		mem_dqs,
		mem_dq,
		mem_SDA,
		mem_SCL,
		mem_SA,

		////////// HSTCC (J5 HSTC-C TOP/J6, HSTC-C BOTTOM), connect to ETHERNET_C(Ethernet Board) //////////
		HSTCC_HSMC_SCL,
		HSTCC_HSMC_SDA,
		HSTCC_NET0_GTX_CLK,
		HSTCC_NET0_INTN,
		HSTCC_NET0_LINK1000,
		HSTCC_NET0_MDC,
		HSTCC_NET0_MDIO,
		HSTCC_NET0_RESETN,
		HSTCC_NET0_RX_CLK,
		HSTCC_NET0_RX_COL,
		HSTCC_NET0_RX_CRS,
		HSTCC_NET0_RX_D,
		HSTCC_NET0_RX_DV,
		HSTCC_NET0_RX_ER,
		HSTCC_NET0_S_CLKN,
		HSTCC_NET0_S_CLKP,
		HSTCC_NET0_S_RX_N,
		HSTCC_NET0_S_RX_P,
		HSTCC_NET0_S_TX_N,
		HSTCC_NET0_S_TX_P,
		HSTCC_NET0_TX_CLK,
		HSTCC_NET0_TX_D,
		HSTCC_NET0_TX_EN,
		HSTCC_NET0_TX_ER,
		HSTCC_NET1_GTX_CLK,
		HSTCC_NET1_INTN,
		HSTCC_NET1_LINK1000,
		HSTCC_NET1_MDC,
		HSTCC_NET1_MDIO,
		HSTCC_NET1_RESETN,
		HSTCC_NET1_RX_CLK,
		HSTCC_NET1_RX_COL,
		HSTCC_NET1_RX_CRS,
		HSTCC_NET1_RX_D,
		HSTCC_NET1_RX_DV,
		HSTCC_NET1_RX_ER,
		HSTCC_NET1_S_CLKN,
		HSTCC_NET1_S_CLKP,
		HSTCC_NET1_S_RX_N,
		HSTCC_NET1_S_RX_P,
		HSTCC_NET1_S_TX_N,
		HSTCC_NET1_S_TX_P,
		HSTCC_NET1_TX_CLK,
		HSTCC_NET1_TX_D,
		HSTCC_NET1_TX_EN,
		HSTCC_NET1_TX_ER,


		////////// REGULATOR //////////
		JVC_CLK,
		JVC_CS,
		JVC_DATAOUT,
		JVC_DATAIN

	);

//=======================================================
//  PARAMETER declarations
//=======================================================

//=======================================================
//  PORT declarations
//=======================================================
////////// CLOCK //////////
input                     		OSC_BA;
input                     		OSC_BB;
input                     		OSC_BC;
input                     		OSC_BD;
input                     		OSC1_50;
input                     		OSC2_50;
output                    		CLK_OUT;
input                     		EXT_CLK;

////////// LED //////////
output    	[7:0]           	LEDR;
output    	[7:0]           	LEDG;
output    	[7:0]           	LEDB;

////////// SEG7 //////////
output    	[6:0]           	HEX0;
output                    		HEX0_DP;
output    	[6:0]           	HEX1;
output                    		HEX1_DP;

////////// BUTTON //////////
input     	[3:0]           	Button;
input							CPU_RESETn;

////////// SW (SLIDE SWITCH) //////////
input     	[3:0]           	SW;

////////// DIP_SW (DIP SWITCH) //////////
input     	[7:0]           	DIP_SW;

////////// mem (J9, DDR2 SO-DIMM), connect to DDR2_SODIMM(DDR2_SODIMM Board) //////////
inout     	[63:0]          	mem_dq;
output    	[7:0]           	mem_dm;
inout     	[7:0]           	mem_dqsn;
inout     	[7:0]           	mem_dqs;
inout     	[1:0]           	mem_clk;
inout     	[1:0]           	mem_clk_n;
output    	[1:0]           	mem_cke;
output    	[15:0]          	mem_addr;
output    	[2:0]           	mem_ba;
output                    		mem_ras_n;
output                    		mem_we_n;
output    	[1:0]           	mem_cs_n;
output                    		mem_cas_n;
output    	[1:0]           	mem_odt;
inout                     		mem_SDA;
output                    		mem_SCL;
output    	[1:0]           	mem_SA;

////////// HSTCC (J5 HSTC-C TOP/J6, HSTC-C BOTTOM), connect to ETHERNET_C(Ethernet Board) //////////
output                    		HSTCC_HSMC_SCL;
inout                     		HSTCC_HSMC_SDA;
output                    		HSTCC_NET0_GTX_CLK;
output                    		HSTCC_NET0_INTN;
input                     		HSTCC_NET0_LINK1000;
output                    		HSTCC_NET0_MDC;
inout                     		HSTCC_NET0_MDIO;
output                    		HSTCC_NET0_RESETN;
input                     		HSTCC_NET0_RX_CLK;
input                     		HSTCC_NET0_RX_COL;
input                     		HSTCC_NET0_RX_CRS;
input     	[7:0]           	HSTCC_NET0_RX_D;
input                     		HSTCC_NET0_RX_DV;
input                     		HSTCC_NET0_RX_ER;
input                     		HSTCC_NET0_S_CLKN;
input                     		HSTCC_NET0_S_CLKP;
input                     		HSTCC_NET0_S_RX_N;
input                     		HSTCC_NET0_S_RX_P;
output                    		HSTCC_NET0_S_TX_N;
output                    		HSTCC_NET0_S_TX_P;
input                    		HSTCC_NET0_TX_CLK;
output    	[7:0]           	HSTCC_NET0_TX_D;
output                    		HSTCC_NET0_TX_EN;
output                    		HSTCC_NET0_TX_ER;
output                    		HSTCC_NET1_GTX_CLK;
output                    		HSTCC_NET1_INTN;
input                     		HSTCC_NET1_LINK1000;
output                    		HSTCC_NET1_MDC;
inout                     		HSTCC_NET1_MDIO;
output                    		HSTCC_NET1_RESETN;
input                     		HSTCC_NET1_RX_CLK;
input                     		HSTCC_NET1_RX_COL;
input                     		HSTCC_NET1_RX_CRS;
input     	[7:0]           	HSTCC_NET1_RX_D;
input                     		HSTCC_NET1_RX_DV;
input                     		HSTCC_NET1_RX_ER;
input                     		HSTCC_NET1_S_CLKN;
input                     		HSTCC_NET1_S_CLKP;
input                     		HSTCC_NET1_S_RX_N;
input                     		HSTCC_NET1_S_RX_P;
output                    		HSTCC_NET1_S_TX_N;
output                    		HSTCC_NET1_S_TX_P;
input                    		HSTCC_NET1_TX_CLK;
output    	[7:0]           	HSTCC_NET1_TX_D;
output                    		HSTCC_NET1_TX_EN;
output                    		HSTCC_NET1_TX_ER;

////////// REGULATOR //////////
output                    		JVC_CLK;
output                    		JVC_CS;
output                    		JVC_DATAOUT;
input                     		JVC_DATAIN;


//=======================================================
//  IO Group Voltage Configuration (Do not modify it)
//=======================================================
IOV_A2V5_B1V8_C2V5_D2V5 IOV_Instance(
	.iCLK(OSC2_50),
	.iRST_n(global_reset_n),
	.iENABLE(1'b0),
	.oREADY(),
	.oERR(),
	.oERRCODE(),
	.oJVC_CLK(JVC_CLK),
	.oJVC_CS(JVC_CS),
	.oJVC_DATAOUT(JVC_DATAOUT),
	.iJVC_DATAIN(JVC_DATAIN)
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire			global_reset_n;
wire			CLK_125MHz;
reg				LEDR_dummy;
//===== ethernet =====
wire			enet_resetn;
  // clock
wire			tx_clk_ref125;
wire			tx_clk_phy125;
wire			tx_clk_mac;
wire			enet_gtx_clk;
wire			enet_tx_clk;
wire			enet_rx_clk;

  // Management Interface and Interrupt
wire			enet_mdc;
wire			enet_mdio_in;
wire			enet_mdio_oen;
wire			enet_mdio_out;

  // SOPC control signal
wire			ena_10_from_the_tse_mac;
wire			eth_mode_from_the_tse_mac;
wire			set_1000_to_the_tse_mac;
wire			set_10_to_the_tse_mac;

  // local MUX signal
wire			m_rx_col;
wire			m_rx_crs;
wire	[3:0]	m_rx_d;
wire			m_rx_dv;
wire			m_rx_err;
wire	[3:0]	m_tx_d;
wire			m_tx_en;
wire			m_tx_err;
wire	[7:0]	gm_rx_d;
wire			gm_rx_dv;
wire			gm_rx_err;
wire	[7:0]	gm_tx_d;
wire			gm_tx_en;
wire			gm_tx_err;
  //

//=======================================================
//  Structural coding
//=======================================================
// ===== ethernet clock =====
// ===== ethernet signal =====
assign HSTCC_NET0_RESETN		= enet_resetn;
assign HSTCC_NET1_RESETN		= enet_resetn;

`ifdef NET0
assign enet_rx_clk			= HSTCC_NET0_RX_CLK;
assign enet_tx_clk			= HSTCC_NET0_TX_CLK;
assign HSTCC_NET0_GTX_CLK	= enet_gtx_clk;
assign HSTCC_NET0_MDC		= enet_mdc;

`else
assign enet_rx_clk			= HSTCC_NET1_RX_CLK;
assign enet_tx_clk			= HSTCC_NET1_TX_CLK;
assign HSTCC_NET1_GTX_CLK	= enet_gtx_clk;
assign HSTCC_NET1_MDC		= enet_mdc;

`endif

// ===== SOPC control signal defing
assign set_1000_to_the_tse_mac	= 1'b0;
assign set_10_to_the_tse_mac	= 1'b0;


// Ethernet TX PLL
enet_tx_clk_pll enet_tx_clk_pll
(
		.inclk0(OSC1_50),
		.c0(tx_clk_ref125),
		.c1(tx_clk_phy125)
);


gen_reset_n	system_gen_reset_n (
		.tx_clk(OSC1_50),
		.reset_n_in(CPU_RESETn),
		.reset_n_out(global_reset_n)
		);

gen_reset_n	net_gen_reset_n(
		.tx_clk(OSC1_50),
		.reset_n_in(CPU_RESETn),
		.reset_n_out(enet_resetn)
);


DE3_SOPC DE3_SOPC_Instance(
					// 1) global signals:
					.clk(OSC1_50),
					.clk_ddr2(OSC_BB),
					.reset_n(global_reset_n),

					// the_pio_button
					.in_port_to_the_pio_button(Button),

					// the_pio_led
					.out_port_from_the_pio_led({LEDR_dummy, LEDG, LEDB}),

					// the_pio_sw
					.in_port_to_the_pio_sw(SW),

					// the_pio_dip_sw
					.in_port_to_the_pio_dip_sw(DIP_SW),

					// the_SEG7
					.avs_s1_export_seg7_from_the_SEG7({HEX1_DP,HEX1,HEX0_DP,HEX0}),

					// the_altmemddr
					.global_reset_n_to_the_altmemddr(global_reset_n),
					.local_init_done_from_the_altmemddr(),
					.local_refresh_ack_from_the_altmemddr(),
					.local_wdata_req_from_the_altmemddr(),
					.mem_addr_from_the_altmemddr(mem_addr[12:0]),
					.mem_ba_from_the_altmemddr(mem_ba[1:0]),
					.mem_cas_n_from_the_altmemddr(mem_cas_n),
					.mem_cke_from_the_altmemddr(mem_cke[0]),
					.mem_clk_n_to_and_from_the_altmemddr(mem_clk_n),
					.mem_clk_to_and_from_the_altmemddr(mem_clk),
					.mem_cs_n_from_the_altmemddr(mem_cs_n[0]),
					.mem_dm_from_the_altmemddr(mem_dm),
					.mem_dq_to_and_from_the_altmemddr(mem_dq),
					.mem_dqs_to_and_from_the_altmemddr(mem_dqs),
					.mem_dqsn_to_and_from_the_altmemddr(mem_dqsn),
					.mem_odt_from_the_altmemddr(mem_odt[0]),
					.mem_ras_n_from_the_altmemddr(mem_ras_n),
					.mem_we_n_from_the_altmemddr(mem_we_n),
					.oct_ctl_rs_value_to_the_altmemddr(),
					.oct_ctl_rt_value_to_the_altmemddr(),
					.reset_phy_clk_n_from_the_altmemddr(),


					// the_tse_mac (MII / GMII)
					.ena_10_from_the_tse_mac(ena_10_from_the_tse_mac),
					.eth_mode_from_the_tse_mac(eth_mode_from_the_tse_mac),
					.gm_rx_d_to_the_tse_mac(gm_rx_d),
					.gm_rx_dv_to_the_tse_mac(gm_rx_dv),
					.gm_rx_err_to_the_tse_mac(gm_rx_err),
					.gm_tx_d_from_the_tse_mac(gm_tx_d),
					.gm_tx_en_from_the_tse_mac(gm_tx_en),
					.gm_tx_err_from_the_tse_mac(gm_tx_err),
					.m_rx_col_to_the_tse_mac(m_rx_col),
					.m_rx_crs_to_the_tse_mac(m_rx_crs),
					.m_rx_d_to_the_tse_mac(m_rx_d),
					.m_rx_en_to_the_tse_mac(m_rx_dv),
					.m_rx_err_to_the_tse_mac(m_rx_err),
					.m_tx_d_from_the_tse_mac(m_tx_d),
					.m_tx_en_from_the_tse_mac(m_tx_en),
					.m_tx_err_from_the_tse_mac(m_tx_err),
					.mdc_from_the_tse_mac(enet_mdc),
					.mdio_in_to_the_tse_mac(enet_mdio_in),
					.mdio_oen_from_the_tse_mac(enet_mdio_oen),
					.mdio_out_from_the_tse_mac(enet_mdio_out),
					.rx_clk_to_the_tse_mac(enet_rx_clk),
					.set_1000_to_the_tse_mac(set_1000_to_the_tse_mac),
					.set_10_to_the_tse_mac(set_10_to_the_tse_mac),
					.tx_clk_to_the_tse_mac(tx_clk_mac),

					// the_pio_Ethernet card I2C bus
					.out_port_from_the_net_i2c_scl(HSTCC_HSMC_SCL),
					.bidir_port_to_and_from_the_net_i2c_sda(HSTCC_HSMC_SDA),

					// the_pio_ddr2 I2C bus
					.out_port_from_the_ddr2_i2c_scl(mem_SCL),
					.bidir_port_to_and_from_the_ddr2_i2c_sda(mem_SDA)
				
                );

`ifdef	NET0
GMII_MII_MUX INST_MUX(
					//--- PHY Interface
					.reset_rx_clk_n(enet_resetn),
					.phy_rx_clk(enet_rx_clk),
					.phy_rx_col(HSTCC_NET0_RX_COL),
					.phy_rx_crs(HSTCC_NET0_RX_CRS),
					.phy_rx_d(HSTCC_NET0_RX_D),
					.phy_rx_dv(HSTCC_NET0_RX_DV),
					.phy_rx_err(HSTCC_NET0_RX_ER),
					.reset_tx_clk_n(enet_resetn),
					.tx_clk_ref125(tx_clk_ref125),
					.tx_clk_phy125(tx_clk_phy125),
					.tx_clk_mac(tx_clk_mac),
					.tx_clk(enet_tx_clk),
					.phy_gtx_clk(enet_gtx_clk),
					.phy_tx_d(HSTCC_NET0_TX_D),
					.phy_tx_en(HSTCC_NET0_TX_EN),
					.phy_tx_err(HSTCC_NET0_TX_ER),
					.phy_mdio(HSTCC_NET0_MDIO),
					//--- Local MII Interface
					.m_rx_col(m_rx_col),
					.m_rx_crs(m_rx_crs),
					.m_rx_d(m_rx_d),
					.m_rx_dv(m_rx_dv),
					.m_rx_err(m_rx_err),
					.m_tx_d(m_tx_d),
					.m_tx_en(m_tx_en),
					.m_tx_err(m_tx_err),
					//--- Local GMII Interface
					.gm_rx_d(gm_rx_d),
					.gm_rx_dv(gm_rx_dv),
					.gm_rx_err(gm_rx_err),
					.gm_tx_d(gm_tx_d),
					.gm_tx_en(gm_tx_en),
					.gm_tx_err(gm_tx_err),
					//--- 
					.eth_mode(eth_mode_from_the_tse_mac),
					.mdio_in(enet_mdio_in),
					.mdio_oen(enet_mdio_oen),
					.mdio_out(enet_mdio_out)
					);
`else
GMII_MII_MUX INST_MUX(
					//--- PHY Interface
					.reset_rx_clk_n(enet_resetn),
					.phy_rx_clk(enet_rx_clk),
					.phy_rx_col(HSTCC_NET1_RX_COL),
					.phy_rx_crs(HSTCC_NET1_RX_CRS),
					.phy_rx_d(HSTCC_NET1_RX_D),
					.phy_rx_dv(HSTCC_NET1_RX_DV),
					.phy_rx_err(HSTCC_NET1_RX_ER),
					.reset_tx_clk_n(enet_resetn),
					.tx_clk_ref125(tx_clk_ref125),
					.tx_clk_phy125(tx_clk_phy125),
					.tx_clk_mac(tx_clk_mac),
					.tx_clk(enet_tx_clk),
					.phy_gtx_clk(enet_gtx_clk),
					.phy_tx_d(HSTCC_NET1_TX_D),
					.phy_tx_en(HSTCC_NET1_TX_EN),
					.phy_tx_err(HSTCC_NET1_TX_ER),
					.phy_mdio(HSTCC_NET1_MDIO),
					//--- Local MII Interface
					.m_rx_col(m_rx_col),
					.m_rx_crs(m_rx_crs),
					.m_rx_d(m_rx_d),
					.m_rx_dv(m_rx_dv),
					.m_rx_err(m_rx_err),
					.m_tx_d(m_tx_d),
					.m_tx_en(m_tx_en),
					.m_tx_err(m_tx_err),
					//--- Local GMII Interface
					.gm_rx_d(gm_rx_d),
					.gm_rx_dv(gm_rx_dv),
					.gm_rx_err(gm_rx_err),
					.gm_tx_d(gm_tx_d),
					.gm_tx_en(gm_tx_en),
					.gm_tx_err(gm_tx_err),
					//--- 
					.eth_mode(eth_mode_from_the_tse_mac),
					.mdio_in(enet_mdio_in),
					.mdio_oen(enet_mdio_oen),
					.mdio_out(enet_mdio_out)
					);
`endif

// for debug 
assign LEDR[3:0]	= 4'b1111;
assign LEDR[6:4]	= ~{count[25:23]};
assign LEDR[7]	 	= ~eth_mode_from_the_tse_mac;

reg	[31:0]	count;
always @(posedge tx_clk_mac)
begin
	count = count + 1;
end


endmodule
